import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;

/** 
 *    1  11  -           
 * ================================================================================================
 * 
 *        .       
 * 
 * @author   ,   ,  , 
 * @version 26.11.2007
 * @param <V>    
 */
public class Map<V>
{	
	private List<Pair<String,V>> lst; 
	private int numOfKeys;
	
    /**
	 *     
     */
	public Map()
	{
		this.lst = new List<Pair<String,V>>();
		this.numOfKeys = 0;
	}
		
    /**
     *       key;
     *   null     
	 * 
	 * @param key 
	 * @return  
     */
	public V getValue(String key)
	{
		Node<Pair<String,V>> pos = this.lst.getFirst();
	
		while(pos != null)
		{
			if(pos.getInfo().getKey().compareTo(key)==0)
				return pos.getInfo().getValue();
			pos = pos.getNext();
		}
		return null;
	}
	
    /**
     *      key   value  ;
     *   key  ,        value   
     * 
	 * @param key  
	 * @param value  
     */
	public void insert(String key, V value)
	{
		Node<Pair<String,V>> pos = this.lst.getFirst();
		Node<Pair<String,V>> prev = null;
		
		while(pos!=null && key.compareTo(pos.getInfo().getKey())>0)
		{
			prev = pos;
			pos = pos.getNext();
		}
		
		if(pos != null && key.equals(pos.getInfo().getKey()))
			pos.getInfo().setValue(value);
		else 
		{
			this.lst.insert(prev,new Pair<String,V>(key,value));
			this.numOfKeys++;
		}
	}
	
    /**
     *       key    ;
     *        ;
     *        null
	 * 
	 * @param key  
	 * @return   
     */
	public V remove(String key)
	{
		Node<Pair<String,V>> pos = this.lst.getFirst();
		
		while(pos != null)
		{
			if(pos.getInfo().getKey().equals(key))
			{	
				pos = this.lst.remove(pos);
				this.numOfKeys--;
				return pos.getInfo().getValue();
			}
			else
				pos = pos.getNext();
		}
		
		return null;
	}
	
    /**
     *            .
     *   ,    	
	 * 
	 * @return         
     */
	public String[] getAllKeys()
	{
		int k = 0;
		Node<Pair<String,V>> pos = this.lst.getFirst();
		String[] keys = new String[this.numOfKeys];
		
		while(pos != null)
		{
			keys[k] = pos.getInfo().getKey();
			k++;
			pos = pos.getNext();
		}
		return keys;
	}	
	
    /**
     *      
	 * 
	 * @return [key1:value1, key2:value2, key3:value3, ...] :     
     */ 
	public String toString()
	{
		String str = "[";
		Node<Pair<String,V>> pos = this.lst.getFirst();
		
		while(pos != null)
		{
			if(pos.getNext() != null)
				str = str + pos.getInfo().getKey() + ":" + pos.getInfo().getValue().toString() + ", ";
			else
				str = str + pos.getInfo().getKey() + ":" + pos.getInfo().getValue().toString();
			pos = pos.getNext();
		}
		str = str + "]";
		
		return str;
	}
}