import unit4.collectionsLib.*;

/**
 *     1  11 -    1,      1  2
 *
 * @author   ,   ,  , 
 * @version 26.11.2007
 */
public class Dictionary
{
	private Map<Map<Integer>> dicMap;
	
	public Dictionary()
	{
		this.dicMap = new Map<Map<Integer>>();
	}

	public void addWord(String word, String translation)
	{	
		Map<Integer> transMap = this.dicMap.getValue(word);
		
		if(transMap == null)
			transMap = new Map<Integer>();
			
		transMap.insert(translation, 0);
		this.dicMap.insert(word, transMap);
	}
	
	public void delWord(String word)
	{
		this.dicMap.remove(word);
	}

	public String[] getAllWords()
	{
		return this.dicMap.getAllKeys();
	}
		
	public String[] getTranslations(String word) 
	{
		String[] allTranslations;
		Map<Integer> transMap = this.dicMap.getValue(word);
		
		if(transMap == null)
			allTranslations = new String[0];
		else
			allTranslations = transMap.getAllKeys();
		
		return allTranslations;
	}
		
	public String toString()
	{
		int i,j;
		String str = "";
		String[] allTrans;
		String[] allWords = this.getAllWords();
		
		for (i = 0; i < allWords.length; i++)
		{
			str = str + allWords[i] + ": ";
			allTrans = this.getTranslations(allWords[i]);
			for (j = 0; j < allTrans.length-1; j++)
				str = str + allTrans[j] + ",";
			str = str + allTrans[j] + "\n";
		}
		
		return str;
	}
	
	
	// =======================================================
	//      , 
	//    1  11 -    1
	public List<String> translatesTo(String translation)
	{
		List<String> wordsList = new List<String>();
		String[] allWords = this.dicMap.getAllKeys();
		
		for (int i = 0; i < allWords.length; i++)
		{
			Map<Integer> transMap = this.dicMap.getValue(allWords[i]);
			
			if(transMap.getValue(translation) != null)
				wordsList.insert(null,allWords[i]);
		}
		
		return wordsList;
	}
	
	
	//      , 
	//    1  11 -    2 
	public List<String> spellCheck(String sentence)
	{
		List<String> lst = new List<String>();
		String[] words = sentence.split(" ");  //   
		
		for (int i = 0; i < words.length; i++)
		{			
			if(this.dicMap.getValue(words[i]) == null)
					lst.insert(null,words[i]);
		}
		
		return lst;
	}
}
